#include <stdint.h>
#include <stdio.h>
#include <curl/curl.h>
#include <time.h>
#include <string.h>


const char INFLUXURL[] = "http://172.16.3.15:8086/write?db=smarthome2&precision=ms";

#define BUFSIZE 4096
char buffer[BUFSIZE];
char *bufferNextEntry = buffer;

void influxInit() {
    memset(buffer, 0, BUFSIZE);
    bufferNextEntry = buffer;
}

static void influxSendRequest() {
    CURL *curl = curl_easy_init();
    if(curl) {
        curl_easy_setopt(curl, CURLOPT_URL, INFLUXURL);
        curl_easy_setopt(curl, CURLOPT_POSTFIELDS, buffer);
        CURLcode res = curl_easy_perform(curl);
        if(res != CURLE_OK) {
            fprintf(stderr, "curl_easy_perform() failed: %s\n", curl_easy_strerror(res));
        }
        curl_easy_cleanup(curl);
    }
}

void influxAddFrequency(double f) {
    static uint32_t entries = 0;
    char tmpBuf[128]
    struct timespec t;

    clock_gettime(CLOCK_REALTIME, &t);
    uint64_t tt = t.tv_sec * 1000 + t.tv_nsec / 1000000;
    int c = sprintf(tmpBuf, "mainsfrequency freq=%f %l\n", f, tt);
    entries++;


    if ((bufferNextEntry + c + 10) > (buffer + BUFSIZE)) {
        influxSendRequest()
        influxInit();
        printf("%u entries sent to database\n", entries);
        entries = 0;
    }

    memcpy(bufferNextEntry, tmpBuf, c);
    bufferNextEntry += c;
}


